import io.gitlab.jfronny.scripts.*

plugins {
    id("jfmod") version "1.2-SNAPSHOT"
    id("io.gitlab.jfronny.libjf.libjf-config-compiler-plugin")
}

repositories {
    maven("https://maven.shedaniel.me/") { name = "Cloth Config" }
    maven("https://maven.vram.io/") { name = "vram" }
    maven("https://quantumfusion.dev/maven/") {
        content {
            includeGroup("dev.quantumfusion")
            includeGroup("dev.quantumfusion.dashloader")
        }
    }
    maven("https://jitpack.io") { name = "jitpack (for StarScript)" }
}

dependencies {
    modImplementation("net.fabricmc.fabric-api:fabric-api:${prop("fabric_version")}")
    include(modImplementation("io.gitlab.jfronny:muscript:${prop("muscript_version")}")!!)
    modImplementation("io.gitlab.jfronny.libjf:libjf-data-manipulation-v0:${prop("libjf_version")}")
    modImplementation("io.gitlab.jfronny.libjf:libjf-config-core-v1:${prop("libjf_version")}")
    modImplementation("io.gitlab.jfronny.libjf:libjf-config-ui-tiny-v1:${prop("libjf_version")}")
    modClientCompileOnly("io.vram:frex-fabric-mc119:+")

    modLocalRuntime("io.gitlab.jfronny.libjf:libjf-devutil:${prop("libjf_version")}")
    modLocalRuntime("com.terraformersmc:modmenu:4.1.1")

    testImplementation("org.junit.jupiter:junit-jupiter:5.9.0")

    // Canvas for FREX testing
//    modRuntimeOnly("io.vram:canvas-fabric-mc118:+") {
//        exclude(group: "me.shedaniel.cloth")
//    }

    // DashLoader "compatibility"
//    clientRuntimeOnly("dev.quantumfusion.dashloader:dashloader-definitions:3.0-rc14-1.18")
}

//TODO re-enable once minecraft classes can be used in tests again
//test {
//    useJUnitPlatform()
//}
