# Debugging
If you run into issues with respackopts and cannot find a solution here,
you may contact me through my discord server (look at the mod page)

## Look at the config file
Respackopts stores configurations next to their corresponding resource packs (`some pack.zip.rpo` usually)

This file contains all applied config options as saved by respackopts.

## Dump the internal representation
Running `/rpoc dump config` will dump all data available about the enabled packs, including their config options (but not individual configurations like .rpo files)

You can use this if a respackopts.json5 isn't working as expected

## Dump GLSL code
You can run the command `/rpoc dump glsl` to dump the shader code generated by respackopts to a file.

I recommend reading through it if your shader is misbehaving.
The content imported to your shader by the integrations will equal the dumped code.

## Verify that the option you are using exists
One common issue is that you removed an option but still use it somewhere.
The log will usually reference that option and the source.

## Ensure you are using the correct dots
Respackopts only supports normal dots. If you write commas or colons by accident,
your pack WILL fail to load.

## Avoid infinite loops
Ensure that you do not reference an original file or a previous fallback from a fallback.
Respackopts WILL crash if it runs into an infinite loop!

## Contact me for support
If you are unable to identify the issue, you can try [contacting](https://jfronny.gitlab.io/contact.html) me.
As respackopts is a complex mod, there is a non-zero chance that your issue may be caused by a bug in the mod.
Even if the issue is in your code, I can still try helping you fix it.
