package io.gitlab.jfronny.respackopts.filters.util;

import io.gitlab.jfronny.muscript.debug.*;
import io.gitlab.jfronny.respackopts.*;
import io.gitlab.jfronny.respackopts.model.*;
import io.gitlab.jfronny.respackopts.model.cache.*;
import io.gitlab.jfronny.respackopts.util.*;
import net.minecraft.resource.*;

public class FileExclusionProvider {
    public static boolean fileHidden(ResourcePack pack, String file) {
        return FileRpoSearchProvider.modifyWithRpo(file, pack, rpo -> {
            if (rpo.condition == null)
                return false;
            CacheKey key = MetaCache.getKeyByPack(pack);
            try {
                return !rpo.condition.get(MetaCache.getParameter(key));
            } catch (Condition.ConditionException e) {
                String res = "Could not evaluate condition " + file + " (pack: " + key.packName() + ")";
                try {
                    Respackopts.LOGGER.error(res + " with condition:\n" + ObjectGraphPrinter.printGraph(rpo.condition) + ")", e);
                } catch (Throwable ex) {
                    Respackopts.LOGGER.error(res, e);
                }
                return false;
            }
        }, false);
    }
}
