package io.gitlab.jfronny.respackopts.model.cache;

import io.gitlab.jfronny.muscript.ExpressionParameter;
import io.gitlab.jfronny.respackopts.model.DirRpo;
import io.gitlab.jfronny.respackopts.model.FileRpo;
import io.gitlab.jfronny.respackopts.model.PackMeta;
import io.gitlab.jfronny.respackopts.model.tree.ConfigBranch;

import java.util.HashMap;
import java.util.Map;

public record CachedPackState(
        String packId,
        String displayName,
        String packName,
        ConfigBranch configBranch,
        PackMeta metadata,
        Map<String, FileRpo> cachedFileRPOs,
        Map<String, DirRpo> cachedDirRPOs,
        ExpressionParameter expressionParameter
) {
    public CachedPackState(CacheKey key, PackMeta meta, ConfigBranch branch) {
        this(meta.id,
                key.displayName(),
                key.packName(),
                branch,
                meta,
                new HashMap<>(),
                new HashMap<>(),
                new ExpressionParameter(new HashMap<>(branch.getDynamic().getValue())));
    }
}
